/*
 * JBoss, Home of Professional Open Source
 * Copyright , Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.richfaces.component;

import javax.annotation.Generated;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.component.StateHelper;
import org.richfaces.PartialStateHolderHelper;
import org.richfaces.component.AbstractInplaceInput;
import org.richfaces.component.InplaceState;

/**
 *  @author Anton Belevich 


 **/
@Generated({"RichFaces CDK", "4.0.0-SNAPSHOT"})
public class UIInplaceInput extends AbstractInplaceInput
        {

    public static final String COMPONENT_TYPE="org.richfaces.InplaceInput";

    public static final String COMPONENT_FAMILY="org.richfaces.InplaceInput";

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }

    public UIInplaceInput() {
        super();
        setRendererType("org.richfaces.InplaceInputRenderer");
    }



    protected static enum Properties {
        defaultLabel,
        editEvent,
        inputWidth,
        showControls,
        state,
        tabIndex

    }


 
    public String getDefaultLabel() {
        return (String) getStateHelper().eval(Properties.defaultLabel);
    }
    
    public void setDefaultLabel(String defaultLabel) {
        getStateHelper().put(Properties.defaultLabel, defaultLabel);
    }

 
    public String getEditEvent() {
        return (String) getStateHelper().eval(Properties.editEvent, "click");
    }
    
    public void setEditEvent(String editEvent) {
        getStateHelper().put(Properties.editEvent, editEvent);
    }

 
    public String getInputWidth() {
        return (String) getStateHelper().eval(Properties.inputWidth, "100%");
    }
    
    public void setInputWidth(String inputWidth) {
        getStateHelper().put(Properties.inputWidth, inputWidth);
    }

 
    public boolean isShowControls() {
        return Boolean.valueOf(getStateHelper().eval(Properties.showControls, false).toString());
    }
    
    public void setShowControls(boolean showControls) {
        getStateHelper().put(Properties.showControls, showControls);
    }

 
    public org.richfaces.component.InplaceState getState() {
        return (InplaceState) getStateHelper().eval(Properties.state, InplaceState.ready);
    }
    
    public void setState(org.richfaces.component.InplaceState state) {
        getStateHelper().put(Properties.state, state);
    }

 
    public String getTabIndex() {
        return (String) getStateHelper().eval(Properties.tabIndex);
    }
    
    public void setTabIndex(String tabIndex) {
        getStateHelper().put(Properties.tabIndex, tabIndex);
    }

}